#include "adc.h"

//konfiguruje ADC ATMEGA8a
//mode 1:start else:stop
void config_adc(char mode)
{
	if (mode ==1)
	{
		ADMUX=0x40;
		ADCSRA=0x86;	
		return;
	}
	
	ADMUX=0;
}


//Pobiera warto z danego kanau ADC
int get_adc(char channel)
{
	ADMUX &=0xF0;
	ADMUX |= (channel & 0x07);
	ADCSRA |= (1<<6);
	
	while((ADCSRA & (1<<4))==0);
	
	return ADC;
}

//Urednia kilka pomiarw ADC
//average -> liczba pomiarw
int adc_average(char channel, char averages)
{
	uint16_t tmp=0;
	char i;
	
	for(i=0;i<averages;i++)
	{
		tmp+=get_adc(channel);	
	}
	
	tmp /=averages;
	return tmp;
}

//mode 0: jedynie liczby
void get_adc_info(bool mode, uint8_t * buffer, uint8_t channel)
{
	uint8_t cnt;
	uint8_t cnt2;
	uint32_t tmp_analog_val;
	uint32_t tmp_val;
	
	uint8_t aval_str[8][5];
	
	for(cnt=1;cnt<=8;cnt++)
	{
		cnt2=0;
		
		tmp_analog_val=adc_average(cnt-1,5);
		tmp_analog_val *= 280;
		tmp_analog_val /= 1023;

		tmp_val=tmp_analog_val;
		tmp_val = ((tmp_val / 100));
		
		aval_str[cnt-1][cnt2++]=tmp_val+48;
		tmp_val = tmp_analog_val%100;
		tmp_val /= 10;
		aval_str[cnt-1][cnt2++]='.';
		aval_str[cnt-1][cnt2++]=tmp_val+48;
		tmp_val = tmp_analog_val%10;
		aval_str[cnt-1][cnt2++]=tmp_val+48;
		aval_str[cnt-1][cnt2]=0;
	}	
	
	
	
	if (mode == 0) //Send to PC
	{
		rprintfInit(usart_usb_char);
	
		for(cnt=0;cnt<8;cnt++)
		{
			rprintf("ADC%d:",cnt+1);
			usart_usb_string(aval_str[cnt]);
			usart_usb_string("V ");
		}
	
		usart_usb_string("\r\n");
	}
	else //prepare buff to sms
	{ 
		strcpy(buffer,aval_str[channel-1]);
	}		
	
	
}
	

