#include "commands.h"


bool uart_protocol_exec_action(uart_protocol_pack * uart_frames)
{
	bool return_val=0;
	bool val;
	uint8_t string[13];
	uint8_t i;
	uint8_t j;

	uart_protocol * odebrana_ramka;
	odebrana_ramka = uart_frames->receiving;

	if (S1_pressed)
	{
		odebrana_ramka->reqest=read_alarm_name;
		odebrana_ramka->request2=1;
		
	}	
	else
		if (odebrana_ramka->ok_flag == 0) return 0;
	
	string[12]=0;

	switch(odebrana_ramka->reqest)
	{
		//----------------------------------ustalanie nazw wej i wyj sterownika-------------------------------------------
		case set_digin_name:
			led3_on;
			zapisz_element(digital_in,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();
			break;
		case set_digout_name:
			led3_on;
			zapisz_element(digital_out,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();
			break;
		case set_analogin_name:
			led3_on;
			zapisz_element(analog_in,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();
			break;
		case set_alarm_name:
			led3_on;
			zapisz_element(alarm,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();
			break;
		case set_pwm_name:
			led3_on;
			zapisz_element(pwm,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();
			break;
		case set_pin:
			led3_on;
			zapisz_element(pin,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			send_ack();	
			_delay_ms(30);
			debug_txt("Zapisano PIN");	
			break;
		case set_main_num:
			led3_on;
			zapisz_element(main_number,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);
			zapisz_element(start_info,0,&odebrana_ramka->request2,1);
			send_ack();		
			break;
		case set_pass:
			led3_on;
			zapisz_element(password,odebrana_ramka->request2,odebrana_ramka->pakiet_danych,odebrana_ramka->len);	
			send_ack();	
			_delay_ms(30);
			debug_txt("Zapisano HASLO");	
			break;
		//-------------------------------------wysyanie zapisanych danych do programu---------------------------------	
		case read_digin_name:
			led3_on;
			i=odebrana_ramka->request2;
			czytaj_element(digital_in,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_digin_name,i,string,strlen(string),0,10);
			//send_ack();
			break;
		case read_analogin_name:
			led3_on;
			i=odebrana_ramka->request2;
			czytaj_element(analog_in,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_analogin_name,i,string,strlen(string),0,10);
			break;
		case read_digout_name:
			led3_on;
			i=odebrana_ramka->request2;
			czytaj_element(digital_out,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_digout_name,i,string,strlen(string),0,10);
			break;
		case read_alarm_name:
			led3_on;
			i=odebrana_ramka->request2;
			czytaj_element(alarm,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_alarm_name,i,string,strlen(string),0,10);
			break;	
		case read_pwm_name:
			led3_on;
			i=odebrana_ramka->request2;
			czytaj_element(pwm,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_pwm_name,i,string,strlen(string),0,10);
			break;										
		case read_main_num:
			led3_on;
			czytaj_element(start_info,0,string,1);
			i=string[0];
			czytaj_element(main_number,i,string,string_max_len);
			send_protocol_frame(uart_frames,0,0, send_main_num,i,string,strlen(string),0,10);	
			break;
		//------------------------------------Ustalanie stanu wyj cyfrowych----------------------------------------									
		case set_digout_state:
			led3_on;
			i=odebrana_ramka->request2;
			
			if (odebrana_ramka->pakiet_danych[0]==0)
				val=0;
			else
				val=1;
				
			if (i==13)
			{
				for (j=1;j<=12;j++)
				{
					sim900_gpio_exec(0,j,1,val);	
				}
			} else
				sim900_gpio_exec(0,i,1,val);		
			break;
			
		case set_pwm_state:
			led3_on;
			i=odebrana_ramka->request2;
			
			if (i==1)	
			{
				set_pwm_val(true,false,odebrana_ramka->pakiet_danych[0],0);
			}
			else if (i==2)
			{
				set_pwm_val(false,true,0,odebrana_ramka->pakiet_danych[0]);	
			}
		
		default:
			break;
	}
	
	odebrana_ramka->ok_flag = 0;
	led3_off;
	return 1;
	
}


