#include "gsm_commands.h"

bool gsm_command_verify(SIM900_struct * SIM900STRUCT)
{
	uint8_t * pointer=0;

	//-------------------------------Poczenie przychodzce---------------------------------
	pointer = strstr(SIM900STRUCT->recv_buffer,"\r\n+CRING: VOICE\r\n\r\n+CLIP:");
	if (pointer !=NULL)
	{
		_delay_ms(200);
		if (sim900_parse_call(SIM900STRUCT,pointer)==1)
		{					
//			debug_txt("\n\rDzwoni: ");
//			debug_txt(SIM900STRUCT->info.incoming_call_nr);
//			debug_txt("\n\r");
		}			
		
		
		if (SIM900STRUCT->opcje.auto_ans)
			sim900_call_ans();
		else if (SIM900STRUCT->opcje.auto_hangup)
			sim900_call_refuse();
			
			
		SIM900STRUCT->recv_buffer[0]=0;
		SIM900STRUCT->buffer_element=0;
		
		return 1;
	}
	//------------------------------------ODBIR SMSA-----------------------------------------
	pointer = strstr(SIM900STRUCT->recv_buffer,"\r\n+CMT");
	if (pointer !=NULL)
	{
		delay_ms(500);
		sim900_parse_sms(SIM900STRUCT,pointer);
		check_sms_message(SIM900STRUCT);
		
		
		SIM900STRUCT->recv_buffer[0]=0;
		SIM900STRUCT->buffer_element=0;
		
		return 1;
	}	
	return 0;
}



bool sim900_parse_call(SIM900_struct * SIM900STRUCT, uint8_t * wsk)
{
	uint8_t temp_counter=0;
	uint8_t chr;
	
	for(temp_counter=0;temp_counter<27;temp_counter++)
	{
		wsk++;
		if ((*wsk) == 0) return 0;
	}
	
	for(temp_counter=0;temp_counter<15;temp_counter++)
	{
		chr = *(wsk++);
		
		if (chr == 0) return 0;
		
		if (chr != 0x22)
		{
			SIM900STRUCT->info.incoming_call_nr[temp_counter]=chr;
			SIM900STRUCT->info.incoming_call_nr[temp_counter+1]=0;			
		}	
		else
			break;			
	}
	return 1;
}


bool sim900_parse_sms(SIM900_struct * SIM900STRUCT, uint8_t * wsk)
{
	uint8_t temp_counter;
	uint8_t chr;
	
	SIM900STRUCT->info.received_sms.number[0]=0;
	SIM900STRUCT->info.received_sms.date[0]=0;
	SIM900STRUCT->info.received_sms.time[0]=0;
	SIM900STRUCT->info.received_sms.msg[0]=0;
				
	//-----------------------numer telefonu--------------------------
	
	for(temp_counter=0;temp_counter<9;temp_counter++)
	{
		wsk++;
		if ((*wsk) == 0) return 0;
	}
	
	for(temp_counter=0;temp_counter<15;temp_counter++)
	{
		chr = *(wsk++);
		
		if (chr == 0) return 0;
		
		if (chr != 0x22)
		{
			SIM900STRUCT->info.received_sms.number[temp_counter]=chr;
			SIM900STRUCT->info.received_sms.number[temp_counter+1]=0;			
		}	
		else
			break;			
	}
	
//	debug_txt("\n\rOdebrano SMS: Nadawca: ");
//	debug_txt(SIM900STRUCT->info.received_sms.number);
	
	//----------------------------data-------------------------------

	temp_counter=0;
	while(*wsk)
	{
		if (*wsk==0) return 0;
		if (*wsk == ',') temp_counter++;
		wsk++;
		
		if (temp_counter==2) break;		
	}
	
	wsk+=1; //przeskoczenie \"
	
	for(temp_counter=0;temp_counter<9;temp_counter++)
	{
		chr = *(wsk++);
		if (chr == 0) return 0;
		
		if (chr != ',')
		{
			SIM900STRUCT->info.received_sms.date[temp_counter]=chr;
			SIM900STRUCT->info.received_sms.date[temp_counter+1]=0;			
		}	
		else
			break;			
	}
	
//	debug_txt("\n\rData: ");
//	debug_txt(SIM900STRUCT->info.received_sms.date);
	//-------------------------Godzina----------------------------
	
	
	for(temp_counter=0;temp_counter<9;temp_counter++)
	{
		chr = *(wsk++);
		if (chr == 0) return 0;
		
		if ((chr != '+') && (chr != 0x0D))
		{
			SIM900STRUCT->info.received_sms.time[temp_counter]=chr;
			SIM900STRUCT->info.received_sms.time[temp_counter+1]=0;			
		}	
		else
			break;	
	}			
			
//	debug_txt("\n\rGodzina: ");
//	debug_txt(SIM900STRUCT->info.received_sms.time);
	//-----------------------Pole danych--------------------------
	
	while (*wsk != 0x0A)
	{
		if ((*wsk) == 0) return 0;
		wsk++;
	}
	
	wsk++;
	
	
	
	temp_counter=0;
	
	while (*wsk !=0)
	{
		chr = *wsk++;
		
		if (temp_counter < 98)
		{
			SIM900STRUCT->info.received_sms.msg[temp_counter++]=chr;
			SIM900STRUCT->info.received_sms.msg[temp_counter]=0;
		}
		else
			break;
	}	
			
//	debug_txt("\n\rWiadomosc: ");
//	debug_txt(SIM900STRUCT->info.received_sms.msg);
	return 1;
}