#include "pamiec_konfiguracji.h"


void zapisz_element(device_type device, uint8_t device_number, uint8_t* buf, uint8_t len)
{
	uint16_t i;
	
	if (len > string_max_len) len = string_max_len;
	
	while(eeprom_is_ready()==0);
	
	switch (device)
	{
		case pin:
			i=1;
			break;
		case main_number:
			i=1 + string_max_len;
			break;
		case password:
			i=1 + 2*string_max_len;
			break;
		case alarm:
			if (device_number == 1) 
				i=1 + 3*string_max_len;
			else
				i=1 + 4*string_max_len;
			break;
		case pwm:
			if (device_number == 1) 
				i=1 + 5*string_max_len;
			else
				i=1 + 6*string_max_len;
			break;
		case digital_out:
			if (device_number > 12) device_number =12;
			i=1 + 6*string_max_len + device_number * string_max_len;
			break;
		case digital_in:
			if (device_number > 12) device_number =12;
				i=1 + 18*string_max_len + device_number * string_max_len;
			break;
		case analog_in:
			if (device_number > 12) device_number =12;
				i=1 + 30*string_max_len + device_number * string_max_len;
			break;
		case start_info:
			i=1 + 38*string_max_len + 1 * string_max_len;
			break;
	}
	
	eeprom_write_block(buf,i,len);
} 

void czytaj_element(device_type device, uint8_t device_number, uint8_t* buf, uint8_t len)
{
	uint16_t i;
	while(eeprom_is_ready()==0);
	
	
	if (len > string_max_len) len = string_max_len;
	

	switch (device)
	{
		case pin:
			i=1;
			break;
		case main_number:
			i=1 + string_max_len;
			break;
		case password:
			i=1 + 2*string_max_len;
			break;
		case alarm:
			if (device_number == 1) 
				i=1 + 3*string_max_len;
			else
				i=1 + 4*string_max_len;
			break;
		case pwm:
			if (device_number == 1) 
				i=1 + 5*string_max_len;
			else
				i=1 + 6*string_max_len;
			break;
		case digital_out:
			if (device_number > 12) device_number =12;
			i=1 + 6*string_max_len + device_number * string_max_len;
			break;
		case digital_in:
			if (device_number > 12) device_number =12;
				i=1 + 18*string_max_len + device_number * string_max_len;
			break;
		case analog_in:
			if (device_number > 12) device_number =12;
				i=1 + 30*string_max_len + device_number * string_max_len;
			break;
		case start_info:
				i=1 + 38*string_max_len + 1 * string_max_len;
			break;
	}
	
	eeprom_read_block(buf,i,len);
}

void erase_eeprom(void)
{
	uint8_t cnt;
		
	for (cnt=1;cnt<1000;cnt++) 
	{
		wdt_reset();
		while(eeprom_is_ready()==0);
		eeprom_write_byte(cnt,0);
	}
}


#ifdef debug
void debug_eeprom(void)
{
	uint8_t x_buf[13];
	uint8_t ii=0;
	
	usart_usb_string("\n\rWejscia cyfrowe: ");
		
	for (ii=1;ii<=12;ii++)
	{
		czytaj_element(digital_in,ii,x_buf,12);
		x_buf[12]=0;
		
		usart_usb_string(x_buf);
		usart_usb_string(" ");
		
	}
		
	usart_usb_string("\n\rWejscia analogowe: ");
		
	for (ii=1;ii<=8;ii++)
	{
		czytaj_element(analog_in,ii,x_buf,12);
		x_buf[12]=0;
		
		usart_usb_string(x_buf);
		usart_usb_string(" ");
		
	}				

	usart_usb_string("\n\rWyjscia cyfrowe: ");
		
	for (ii=1;ii<=12;ii++)
	{
		czytaj_element(digital_out,ii,x_buf,12);
		x_buf[12]=0;
		
		usart_usb_string(x_buf);
		usart_usb_string(" ");
		
	}	
	
	usart_usb_string("\n\rAlarm: ");
		
	for (ii=1;ii<=2;ii++)
	{
		czytaj_element(alarm,ii,x_buf,12);
		x_buf[12]=0;
		
		usart_usb_string(x_buf);
		usart_usb_string(" ");
		
	}	
	
		usart_usb_string("\n\rPWM: ");
		
	for (ii=1;ii<=2;ii++)
	{
		czytaj_element(pwm,ii,x_buf,12);
		x_buf[12]=0;
		
		usart_usb_string(x_buf);
		usart_usb_string(" ");
		
	}
		
	usart_usb_string("\n\rPIN: ");
	czytaj_element(pin,0,x_buf,12);
	x_buf[12]=0;
	usart_usb_string(x_buf);
	usart_usb_string(" ");

	usart_usb_string("\n\rCenter: ");
	czytaj_element(sms_center,0,x_buf,12);
	x_buf[12]=0;
	usart_usb_string(x_buf);
	usart_usb_string(" ");
		
	usart_usb_string("\n\rPASS: ");
	czytaj_element(password,0,x_buf,12);
	x_buf[12]=0;
	usart_usb_string(x_buf);
	usart_usb_string(" ");		
		
	usart_usb_string("\n\r");	
}
#endif