/*
 * pamiec_konfiguracji.h
 *
 * Created: 2012-03-13 17:04:33
 *  Author: Radek
 */ 


#ifndef PAMIEC_KONFIGURACJI_H_
#define PAMIEC_KONFIGURACJI_H_

#include <avr/eeprom.h>
#include <avr/io.h>
#include <avr/wdt.h>

#include "uart_protocol.h"

//#define debug


#define string_max_len 12
typedef enum {analog_in, digital_in, digital_out, alarm, pwm, pin, password, main_number, start_info} device_type;


//Zapisuje do EEPROM
//max len : #define string_max_len 12
void zapisz_element(device_type device, uint8_t device_number, uint8_t* buf, uint8_t len);

//Odczytuje z pamici EEPROM zapisane dane
void czytaj_element(device_type device, uint8_t device_number, uint8_t* buf, uint8_t len);

//czyci ca pami eeprom
void erase_eeprom(void);


#ifdef debug
void debug_eeprom(void);
#endif



#endif /* PAMIEC_KONFIGURACJI_H_ */