#include "relays.h"


//Funkcja inicjalizujca porty przekanikw
//porty pracuj jako wyjcia. Stan przekanikw
//po wywoaniu niekatywny
void ports_init(void)
{
 //---konfiguracja pinw wej cyfrowych
 //porty jako wejscia
 DDR(digin1_port) &= ~(1<<digin1_pin); //dig in1
 DDR(digin2_port) &= ~(1<<digin2_pin); //dig in2
 DDR(digin3_port) &= ~(1<<digin3_pin); //dig in3 
 DDR(digin4_port) &= ~(1<<digin4_pin); //dig in4
 DDR(digin5_port) &= ~(1<<digin5_pin); //dig in5
 DDR(digin6_port) &= ~(1<<digin6_pin); //dig in6
 DDR(digin7_port) &= ~(1<<digin7_pin); //dig in7 
 DDR(digin8_port) &= ~(1<<digin8_pin); //dig in8
 DDR(digin9_port) &= ~(1<<digin9_pin); //dig in9
 DDR(digin10_port) &= ~(1<<digin10_pin); //dig in10
 DDR(digin11_port) &= ~(1<<digin11_pin); //dig in11
 DDR(digin12_port) &= ~(1<<digin12_pin); //dig in12
 //wew. pullup
 PORT(digin1_port) |= (1<<digin1_pin); //dig in1
 PORT(digin2_port) |= (1<<digin2_pin); //dig in2
 PORT(digin3_port) |= (1<<digin3_pin); //dig in3 
 PORT(digin4_port) |= (1<<digin4_pin); //dig in4
 PORT(digin5_port) |= (1<<digin5_pin); //dig in5
 PORT(digin6_port) |= (1<<digin6_pin); //dig in6
 PORT(digin7_port) |= (1<<digin7_pin); //dig in7 
 PORT(digin8_port) |= (1<<digin8_pin); //dig in8
 PORT(digin9_port) |= (1<<digin9_pin); //dig in9
 PORT(digin10_port) |= (1<<digin10_pin); //dig in10
 PORT(digin11_port) |= (1<<digin11_pin); //dig in11
 PORT(digin12_port) |= (1<<digin12_pin); //dig in12


 DDR(led_port1) |= 1<<led_pin1;
 DDR(led_port2) |= 1<<led_pin2;
 DDR(led_port3) |= 1<<led_pin3;
 
 //Konfiguracja przycisku S1
 DDRB &= (~(1<<0));
 PORTB |= 1;
 
 //Konfigiguracja wej Alert
 DDRG &= (~(1)); //Alert1
 PORTG |= 1;
 
 DDRG &= (~(1<<1)); //Alert2
 PORTG |= 1<<1;
 
 //Konfiguracja PINW PWM
 DDRB |= 1<<5; // PWM1
 PORTB &= (~(1<<5));
 
 DDRB |= 1<<6; // PWM2
 PORTB &= (~(1<<6));
}


pwm_state set_pwm_val(bool pwm1_refresh, bool pwm2_refresh, uint16_t pwm1_val, uint16_t pwm2_val)
{
	pwm_state tmp;
	
	if (pwm1_refresh)
	{
		if (pwm1_val == 0)
			TCCR1A &= (~(1 << COM1A1));
		else
			TCCR1A |= ((1 << COM1A1));
			
		OCR1A = pwm1_val & 0x3FF;
		
		
	}
	
	if (pwm2_refresh)
	{
		if (pwm2_val == 0)
			TCCR1A &= (~(1 << COM1B1));
		else
			TCCR1A |= ((1 << COM1B1));
		
		OCR1B = pwm2_val & 0x3FF;
	}
	
	tmp.pwm1 = OCR1A;
	tmp.pwm2 = OCR1B;
	return tmp;
}

void config_pwm(void)
{
   TCCR1A = ((1 << COM1A1) | (1 << COM1B1) | (1 << WGM10)); 
   TCCR1B = ((1 << WGM12) | (1 << CS10) | (1 << CS11));  // timer 1 ustawienie fast pwm(mode 7), prescaler 64 
   
   set_pwm_val(1,1,0,0);
}

//ustawia wszystkie przekazniki na podstawie bajtu
//MSB musi byc = 1 zeby zezwolic na ustawienie
//[allow1 pk1 pk2 pk3 .. pk7]
int all_rel(int mode)
{
	uint16_t val=0;
	uint8_t cnt=0;
	
	wdt_reset();
	
	if ((mode & 0x8000) != 0) //gdy bit MSB zmiennej mode=1 ustaw wyjcia cyfrowe
	{
		for (cnt=1;cnt<=12;cnt++)
		{
			wdt_reset();
			
			if ((mode & (1<<(12-cnt))) == 0)
				val =0;
			else
				val= 1;
				
			sim900_gpio_exec(0,cnt,1,val);
		}
	}		
}

//8 bitw -> 4 najstarsze wej1 wej2 wej3 wej4
int digin_info(void)
{
	int state=0;
	
	if ((PIN(digin1_port) & (1<<digin1_pin)) ==0 ) state    = 0b0000000000000001;
	if ((PIN(digin2_port) & (1<<digin2_pin)) ==0 ) state   |= 0b0000000000000010;
	if ((PIN(digin3_port) & (1<<digin3_pin)) ==0 ) state   |= 0b0000000000000100;
	if ((PIN(digin4_port) & (1<<digin4_pin)) ==0 ) state   |= 0b0000000000001000;
	if ((PIN(digin5_port) & (1<<digin5_pin)) ==0 ) state   |= 0b0000000000010000;
	if ((PIN(digin6_port) & (1<<digin6_pin)) ==0 ) state   |= 0b0000000000100000;
	if ((PIN(digin7_port) & (1<<digin7_pin)) ==0 ) state   |= 0b0000000001000000;
	if ((PIN(digin8_port) & (1<<digin8_pin)) ==0 ) state   |= 0b0000000010000000;
	if ((PIN(digin9_port) & (1<<digin9_pin)) ==0 ) state   |= 0b0000000100000000;
	if ((PIN(digin10_port) & (1<<digin10_pin)) ==0 ) state |= 0b0000001000000000;
	if ((PIN(digin11_port) & (1<<digin11_pin)) ==0 ) state |= 0b0000010000000000;
	if ((PIN(digin12_port) & (1<<digin12_pin)) ==0 ) state |= 0b0000100000000000;
	
	return state;
}




//1 - swieci, 0 - off , 2 - slow_blink, 3-fast_blink, 4- pulse, 5-timer_int
void led_mode(char led)
{
	static char mode;
	static char cnt;
	
	
	
	if (led != 5)
	{
		mode = led;
		return;
	} 
	else
	{
		cnt++;
		if (cnt==32) cnt=0;
		
		switch (mode)
		{
			case 0: //off
				//led_off;
				break;
			case 1: //on
				//led_on;
				break;
			case 2: //fast blink
				//if ((cnt==10) || (cnt==20) || (cnt==0))   led_tg;
				break;
			case 3: //slow blink
			   // if ((cnt==0) ||(cnt==4) || (cnt==8) || (cnt==12) ||(cnt==16) || (cnt==20) || (cnt==24)|| (cnt==28)) led_tg;
				break;
			case 4:
			   // if ((cnt==0) ||(cnt==1)) led_on; else led_off;
				break;
			default:
				break;
		}
	
	return;
}
	}