#ifndef H_relays
#define H_relays

#include "avr/io.h"
//#include "pamiec_konfiguracji.h"
#include "sim900.h"
#include <stdbool.h>
#include <string.h>
#include <inttypes.h>
#include <avr/wdt.h>

//-----------------definicje pinw-------------------
//--------------diody sygnalizacyjne-----------------
#define led_port1 G
#define led_pin1 2

#define led_port2 G
#define led_pin2 3

#define led_port3 G
#define led_pin3 4

//----GSM_zas_MOS----
#define gsm_zas_mos_port B
#define gsm_zas_mos_pin 1
//----GSM PWR PIN------
#define gsm_pwr_port B
#define gsm_pwr_pin 0



//-----porty wej cyfrowych-----
#define digin1_port C
#define digin1_pin 0
#define digin2_port C
#define digin2_pin 1
#define digin3_port C
#define digin3_pin 2
#define digin4_port C
#define digin4_pin 3
#define digin5_port A
#define digin5_pin 7
#define digin6_port A
#define digin6_pin 6
#define digin7_port A
#define digin7_pin 5
#define digin8_port A
#define digin8_pin 4
#define digin9_port A
#define digin9_pin 3
#define digin10_port A
#define digin10_pin 2
#define digin11_port A
#define digin11_pin 1
#define digin12_port A
#define digin12_pin 0

#define input 0
#define output 1


typedef struct
{
	uint16_t pwm1;
	uint16_t pwm2;
} pwm_state;

//Zmienia stan bitu dowolnego rejestru
//reg - rejestr
//num_of_bit - numer bitu
//mod - dzialanie (input, output, float, pull_up, toggle)

#define conf_reg(num,mod) conf_reg_tmp(num,mod) 
#define conf_reg_tmp(num,mod) ((mod)==(output) ? (|= 1<<num) : (&= ~(1<<num)))
#define config_register(reg,num_of_bit,mod) (reg## (conf_reg(num_of_bit,mod)) )


#define PORT(x) XPORT(x) 
#define XPORT(x) (PORT##x) 

#define DDR(x) DDRx(x) 
#define DDRx(x) ( DDR##x ) 

#define PIN(x) PINx(x) 
#define PINx(x) ( PIN##x ) 


#define led1_on  PORT(led_port1) |= 1<<led_pin1
#define led1_off PORT(led_port1) &= ~(1<<led_pin1)
#define led1_tg  PORT(led_port1) ^= (1<<led_pin1)

#define led2_on  PORT(led_port2) |= 1<<led_pin2
#define led2_off PORT(led_port2) &= ~(1<<led_pin2)
#define led2_tg  PORT(led_port2) ^= (1<<led_pin2)

#define led3_on  PORT(led_port3) |= 1<<led_pin3
#define led3_off PORT(led_port3) &= ~(1<<led_pin3)
#define led3_tg  PORT(led_port3) ^= (1<<led_pin3)

#define S1_pressed  (!(PINB & 0x01))

#define is_ALERT1 (!(PING & 0x01))
#define is_ALERT2 (!(PING & 0x02))


//Funkcja inicjalizujca wszystkie porty
//porty pracuj jako wyjcia. Stan przekanikw
//po wywoaniu niekatywny
void ports_init(void);

//Ustawia odpowiedni warto kanaw pwm. Tylko, jeeli parametr pwm_refresh jest ustawiony na 1
//zwraca biec warto kanaw PWM
pwm_state set_pwm_val(bool pwm1_refresh, bool pwm2_refresh, uint16_t pwm1_val, uint16_t pwm2_val);

//inicjalizuje PWM
void config_pwm(void);

//ustawia lub zwraca stan wszystkich przekaznikw na podstawie bajtu mode
//mode [1ustawia/0 daje stan | pk1 pk2 pk3 .. pk7]
int all_rel(int mode);

//zwraca stan wej cyfrowych
//12 bitw -> od najstarszych wej1 wej2 wej3 wej4 ... wej12
int digin_info(void);

//steruje prac diody led
//1 - swieci, 0 - off , 2 - slow_blink, 3-fast_blink, 4- pulse, 5-timer_int
void led_mode(char led);

#endif