#include "sms_command.h"


bool check_sms_message(SIM900_struct * sim900_struct)
{
	bool analog_in_send=0;
	bool digital_in_send =0;
	bool digital_out_send =0;
	bool pwm_alarm_send =0;
	
	uint8_t * pointer;
	uint16_t val;
	
	uint16_t out_val;
	
	uint8_t tmp_cnt;
	uint8_t temp_command[6];
	bool retval=0;
	uint8_t err_cnt;
	
	//---------------------------------------Sprawdzenie hasa sms----------------------------------------------
	for (tmp_cnt=0;tmp_cnt<strlen(sim900_struct->opcje.pass);tmp_cnt++)
	{
		if (sim900_struct->opcje.pass[tmp_cnt] != sim900_struct->info.received_sms.msg[tmp_cnt]) return 0;
	}
	
	if ((sim900_struct->info.received_sms.msg[strlen(sim900_struct->opcje.pass)]) != ' ') return 0;
	//----------------------------------------------------------------------------------------------------------
	
	strcpy(temp_command,"Wxx:v"); //xx: numer urzdzenia 01,02,...,12 ; v: warto 1:zacz 0:wycz
	
	if (strstr(sim900_struct->info.received_sms.msg,"a_in")!=NULL)  analog_in_send=1;
	if (strstr(sim900_struct->info.received_sms.msg,"d_in")!=NULL)  digital_in_send=1;
	if (strstr(sim900_struct->info.received_sms.msg,"d_out")!=NULL) digital_out_send=1;
	if (strstr(sim900_struct->info.received_sms.msg,"oth")!=NULL)   pwm_alarm_send=1;
	
	if (strstr(sim900_struct->info.received_sms.msg,"allon")!=NULL) {all_rel(0xFFFF); digital_out_send=1;}
	if (strstr(sim900_struct->info.received_sms.msg,"alloff")!=NULL) {all_rel(0x8000); digital_out_send=1;}
		
	if (strstr(sim900_struct->info.received_sms.msg,"A1_reset")!=NULL) {sim900_struct->opcje.allow_alarm1=1; pwm_alarm_send=1;}
	if (strstr(sim900_struct->info.received_sms.msg,"A2_reset")!=NULL) {sim900_struct->opcje.allow_alarm2=1; pwm_alarm_send=1;}
		
	if ((pointer=strstr(sim900_struct->info.received_sms.msg,"pwm1:"))!=NULL) 
	{
		if (get_val_from_str(pointer,&val)==1)
		{
			set_pwm_val(1,0,val,0);
			pwm_alarm_send=1;
		}	
	}
		
	if ((pointer=strstr(sim900_struct->info.received_sms.msg,"pwm2:"))!=NULL) 
	{
		if (get_val_from_str(pointer,&val)==1)
		{
			set_pwm_val(0,1,0,val);
			pwm_alarm_send=1;
		}	
	}
	
	for(tmp_cnt = 1; tmp_cnt <=12;tmp_cnt++)
	{
		if (tmp_cnt <10)
		{
			temp_command[1]='0';
			temp_command[2]=tmp_cnt + '0';
		} 
		else 
		{
			temp_command[1]='1';
			temp_command[2]=(tmp_cnt - 10) + '0';			
		}
		
		temp_command[4]='0';
		if (strstr(sim900_struct->info.received_sms.msg,temp_command)!=NULL) {sim900_gpio_exec(0,tmp_cnt,1,0); digital_out_send=1; continue;}
				
		temp_command[4]='1';
		if (strstr(sim900_struct->info.received_sms.msg,temp_command)!=NULL) {sim900_gpio_exec(0,tmp_cnt,1,1); digital_out_send=1;}	
	}	
	
	
	if (analog_in_send == 1)
	{
		analog_in_msg(sim900_struct->send_buffer);
		
		#ifndef sms_off 
		
		err_cnt=3;
		
		do 
		{
			retval=sim900_send_sms(sim900_struct->info.received_sms.number,sim900_struct->send_buffer);
			err_cnt--;
			
		} while ((retval == 0) && (err_cnt));
		
		#else
		
		debug_txt("\n\r\n\r");
		debug_txt(sim900_struct->send_buffer);	
		#endif
		

	}
	
	if (digital_in_send == 1)
	{
		digital_in_msg(sim900_struct->send_buffer);
		
		#ifndef sms_off 
				
		err_cnt=3;
		do 
		{
			retval=sim900_send_sms(sim900_struct->info.received_sms.number,sim900_struct->send_buffer);
			err_cnt--;
			
		} while ((retval == 0) && (err_cnt));
		
		#else
	
		debug_txt("\n\r\n\r");
		debug_txt(sim900_struct->send_buffer);		
		
		#endif
	}
	
	if (digital_out_send == 1)
	{
		digital_out_msg(sim900_struct->send_buffer);

		#ifndef sms_off 

		err_cnt=3;
		do 
		{
			retval=sim900_send_sms(sim900_struct->info.received_sms.number,sim900_struct->send_buffer);
			err_cnt--;
			
		} while ((retval == 0) && (err_cnt));
		
		#else

		debug_txt("\n\r\n\r");
		debug_txt(sim900_struct->send_buffer);	
		
		#endif
	}
	
	if (pwm_alarm_send == 1) 
	{
		alarm_msg(sim900_struct->send_buffer);

		#ifndef sms_off 
		
		err_cnt=3;
		do 
		{
			retval=sim900_send_sms(sim900_struct->info.received_sms.number,sim900_struct->send_buffer);
			err_cnt--;
			
		} while ((retval == 0) && (err_cnt));
		
		
		#else

		debug_txt("\n\r\n\r");
		debug_txt(sim900_struct->send_buffer);	
		
		#endif
	}
	
	return 1;					
}



bool get_val_from_str(uint8_t * str, uint16_t *val)
{
	uint8_t tmp_cnt;
	
	*val=0;
	
	for (tmp_cnt=0;tmp_cnt<5;tmp_cnt++)
	{
		str++;		
		if (((*str) == 0) || ((*str) == ' ')) return 0;
	}
	
	tmp_cnt=3;
	
	while((*str >='0') && (*str <= '9') && (tmp_cnt))
	{
		*val *=10;
		*val += ((*str) - '0');
		str++;
		tmp_cnt--;
	}
	
	*val = *val & 0xFF;
	
	return 1;
}