#include "sms_messages.h"

extern SIM900_struct sim900struct;

uint8_t print_buff[13];
uint8_t print_buff_cnt;

//Wypenia bufor pnt informacjami o wejciach analogowych
void analog_in_msg(uint8_t * pnt)
{
	uint8_t cnt=0;
	pnt[0]=0;
		
	for (cnt = 0 ;cnt < 8 ; cnt++)
	{
		rprintfInit(print_to_buffer);
		print_buff_cnt=0;
		rprintf(" A%d:",cnt+1);
		strcat(pnt,print_buff);
		czytaj_element(analog_in,cnt+1,print_buff,9);
		print_buff[9]=0;
		strcat(pnt,print_buff);
		strcat(pnt,":");	
		get_adc_info(1,print_buff,cnt+1);
		strcat(pnt,print_buff);
		strcat(pnt,"V");
	}	
}

//Wypenia bufor pnt informacjami o wejciach cyfrowych
void digital_in_msg(uint8_t * pnt)
{
	uint8_t cnt=0;
	pnt[0]=0;
		
	uint16_t digin_val = digin_info();	
		
	for (cnt = 0 ;cnt < 12 ; cnt++)
	{
		rprintfInit(print_to_buffer);
		print_buff_cnt=0;
		rprintf(" D%d:",cnt+1);
		strcat(pnt,print_buff);
		czytaj_element(digital_in,cnt+1,print_buff,7);
		print_buff[7]=0;
		strcat(pnt,print_buff);
		strcat(pnt,":");	
		
		if ((digin_val & (1<<cnt)))
			strcat(pnt,"1");	
		else
			strcat(pnt,"0");		
	}	
}

//Wypenia bufor pnt informacjami o wyjciach cyfrowych
void digital_out_msg(uint8_t * pnt)
{
	uint8_t cnt=0;
	pnt[0]=0;

	for (cnt = 0 ;cnt < 12 ; cnt++)
	{
		rprintfInit(print_to_buffer);
		print_buff_cnt=0;
		rprintf(" W%d:",cnt+1);
		strcat(pnt,print_buff);
		czytaj_element(digital_out,cnt+1,print_buff,7);
		print_buff[7]=0;
		strcat(pnt,print_buff);
		strcat(pnt,":");		
		
	if (sim900struct.opcje.out_state[cnt])
		strcat(pnt,"1");	
	else
		strcat(pnt,"0");
	}			
}

//Wypenia bufor pnt informacjami o pwm oraz alarmach
void alarm_msg(uint8_t * pnt)
{
	uint8_t buff[13];
	pnt[0]=0;
	pwm_state pwm_stat = set_pwm_val(0,0,0,0);
	
	//---ALARM1---
	strcpy(pnt,"A1:");
	czytaj_element(alarm,1,buff,10);
	buff[10]=0;
	strcat(pnt,buff);
	strcat(pnt,":");
	
	if (is_ALERT1)
		strcat(pnt,"1");
	else
		strcat(pnt,"0");
		
	strcat(pnt," ");
	
	if (sim900struct.opcje.allow_alarm1)
		strcat(pnt,"od");
	else	
		strcat(pnt,"za");
		
	strcat(pnt,"blokowane ");
	
	
	//---ALARM2---
	strcat(pnt,"A2:");
	czytaj_element(alarm,2,buff,10);
	buff[10]=0;
	strcat(pnt,buff);
	strcat(pnt,":");
	
	if (is_ALERT2)
		strcat(pnt,"1");
	else
		strcat(pnt,"0");
		
	strcat(pnt," ");
	
	if (sim900struct.opcje.allow_alarm2)
		strcat(pnt,"od");
	else	
		strcat(pnt,"za");
		
	strcat(pnt,"blokowane ");
	
	//PWM1
	strcat(pnt,"PWM1:");
	czytaj_element(pwm,1,buff,10);
	buff[10]=0;
	strcat(pnt,buff);
	strcat(pnt,":");
	
	print_buff_cnt=0;
	rprintfInit(print_to_buffer);
	rprintf("%d",pwm_stat.pwm1);
	strcat(pnt,print_buff);
	
	//PWM2
	strcat(pnt," PWM2:");
	czytaj_element(pwm,2,buff,10);
	buff[10]=0;
	strcat(pnt,buff);
	strcat(pnt,":");
	
	print_buff_cnt=0;
	rprintf("%d",pwm_stat.pwm2);
	strcat(pnt,print_buff);	
}



void print_to_buffer(uint8_t chr)
{
	print_buff[print_buff_cnt++]=chr;
	print_buff[print_buff_cnt]=0;
}