#include "uart.h"


void usart_usb_init(int val)
{
	/* Set baud rate */
	UBRR1H = (unsigned char)(val>>8);
	UBRR1L = (unsigned char)val;
	/* Enable receiver and transmitter */
	UCSR1B =   (1<<RXEN1) | (1<<TXEN1) | (1<<RXCIE1);
	/* Set frame format: 8data, 1stop bit */
	UCSR1C = 0b10000110;
}	 

void usart_gsm_init(int val)
{
	/* Set baud rate */
	UBRR0H = (unsigned char)(val>>8);
	UBRR0L = (unsigned char)val;
	/* Enable receiver and transmitter */
	UCSR0B =   (1<<RXEN0) | (1<<TXEN0)  | (1<<RXC0) ;
	/* Set frame format: 8data, 1stop bit */
	//UCSR1C = (1<<URSEL1)|(3<<UCSZ01) ;//| 1<<UCPOL;
	UCSR0C = 0b10000110;
}	



void usart_gsm_char( unsigned char data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSR0A & (1<<UDRE0)) ) {wdt_reset();};
	/* Put data into buffer, sends the data */
	UDR0 = data;
}



void usart_usb_char( unsigned char data )
{
	/* Wait for empty transmit buffer */
	while ( !( UCSR1A & (1<<UDRE1)) ){wdt_reset();};
	/* Put data into buffer, sends the data */
	UDR1 = data;
}


void usart_usb_string(char *str)      
{
 	while(*str) usart_usb_char(*str++);
	_delay_ms(1);
}

void usart_gsm_string(char *str)      
{
 	while(*str) usart_gsm_char(*str++);
}



unsigned char usart_usb_receive()
{
	int cnt=0; 	
	
	/* Wait for data to be received */
	while ( !(UCSR1A & (1<<RXC1)) )
	{
		wdt_reset();
		_delay_us(5);
		cnt++;
		
		if (cnt == 30000) {return 0;}
	}		
	/* Get and return received data from buffer */
	return UDR1;
}

unsigned char usart_gsm_receive()
{
	int cnt=0; 	
	
	/* Wait for data to be received */
	while ( !(UCSR0A & (1<<RXC0)) )
	{
		wdt_reset();
		_delay_us(5);
		cnt++;
		
		if (cnt == 30000) {return 0;}
	}		
	/* Get and return received data from buffer */
	return UDR0;
}

unsigned char usart_gsm_receive_nowait()
{
	if  ( !(UCSR0A & (1<<RXC0)) ) return 0;
	return UDR0;
}

unsigned char usart_usb_receive_wait()
{
	int cnt=0; 	
	
	/* Wait for data to be received */
	while ( !(UCSR1A & (1<<RXC1)) )
	{
		wdt_reset();
	}		
	/* Get and return received data from buffer */
	return UDR1;
}


unsigned char usart_usb_receive_nowait()
{
	int cnt=0; 	
	
	/* Wait for data to be received */
	if ( !(UCSR1A & (1<<RXC1)) )
		return 0;		
	else
		return UDR1;
}


// pobiera jedn lini tekstu poprzez uart
// void get_gsm_line(char* buffer, int max_len, bool wait)
// {
// 	int cnt=0;
// 	char znak=0;
// 	
// 	
// 	
// 	
// 	while(1)
// 	{
// 		wdt_reset();
// 		if (cnt < (max_len))
// 		{
// 			
// 			znak=usart_gsm_receive(wait);
// 			
// 			if (znak == 0) {buffer[0]=0; return;}
// 			
// 			if  ((cnt==0) && (znak==0x0D)) {cnt=1;}
// 			else if  ((cnt==1) && (znak==0x0A)) {cnt=2;}
// 			else if (cnt>=2) 
// 			{
// 				   
// 				    if (znak==0x0D) {break;}
// 					buffer[(cnt-2)]=znak;
// 					buffer[(cnt-1)]=0;
// 					
// 					cnt++;
// 					
// 			}				
// 					
// 		
// 		}
// 		else
// 		{
// 		    break;	
// 		}			
// 	}	
// 	
// }
void send_usb_bin_byte(char data)
{
	char tmp=data;
	char i;
	

	//usart_usb_string("Wartosc bin: ");
	
	for(i=0;i<8;i++)
	{
		if ((tmp & 0x80) == 0x80)
			usart_usb_char('1');
		else
			usart_usb_char('0');
			
		tmp <<=1;
		
		
	}
	//usart_usb_string("\n\r");
}

void send_usb_bin_int(int data)
{
	int tmp=data;
	char i;
	

	//usart_usb_string("Wartosc bin: ");
	
	for(i=0;i<16;i++)
	{
		if ((tmp & 0x8000) == 0x8000)
			usart_usb_char('1');
		else
			usart_usb_char('0');
			
		tmp <<=1;
		
		
	}
	//usart_usb_string("\n\r");
}

